import usb
import time
from random import randint
####################################
MAX_INDEX	= 12
set_led		= 0
get_but		= 1
####################################
class Board:
	def __init__(self):
		self.speed = 1
		#print "Looking for MCU board..."
		dev = self.find_board()
		if not dev: raise "MCU board not found!"
		#print "MCU board found"
		self.handle = dev.open()

	def find_board(self):
		for bus in usb.busses():
			for dev in bus.devices:
				if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
					return dev
		return None
	
	def create_seq(self,n):
		i = 0
		self.seq = []
		while i < n:
			self.seq.append(randint(0,4))
			i += 1
		if __name__ == "__main__": print self.seq

	def play_seq(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
		for x in self.seq:
			self.handle.controlMsg(reqType, set_led, None, x, 1)
			time.sleep(0.2*self.speed)
			self.handle.controlMsg(reqType, set_led, None, x, 0)
			time.sleep(0.2*self.speed)
		#remain_time = 5000
	
	def recv_seq(self):
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		buf = self.handle.controlMsg(reqType, get_but, 1)
		time.sleep(0.05)
		return buf[0]
	
	def start(self):
		key = {62:0, 61:1, 59:2, 55:3, 47:4}
		reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
		self.in_seq = []
		while len(self.in_seq) < len(self.seq):
			v = self.recv_seq()
			#print v,
			if v in key.keys():
				p = key[v]
			else:
				p = None
			#print p
			if p != None:
				self.handle.controlMsg(reqType, set_led, None, p, 1)
				self.in_seq.append(p)
				while v == self.recv_seq():
					pass
				self.handle.controlMsg(reqType, set_led, None, p, 0)
				y = len(self.in_seq)-1
				if self.in_seq[y] != self.seq[y]:
					return False
		return True

	def check(self):
		if self.seq == self.in_seq:
			if __name__ == "__main__": print "brilliant"
			return True
		else:
			if __name__ == "__main__": print "KAK SUD SUD"
			return False
			
	def start_game(self, n):
		self.create_seq(n)
		time.sleep(1)
		self.play_seq()
		self.start()
		return self.check()

if __name__ == "__main__":
	b = Board()
	b.find_board()
	b.start_game(5)
