from board import Board
import sys, os
import pygame

caption = 'Bigfoot'
data_file = 'data'

class button(pygame.sprite.Sprite):
	def __init__(self, x ,y, name, val):
		pygame.sprite.Sprite.__init__(self)
		self.over, self.rect = load_image(name)
		self.image, tmp = load_image("o_"+name)
		self._image = self.image
		self.rect.bottomleft = (x, y)
		self.w, self.h = self.image.get_size()
		self.angle = 0
		self.val = val

	def update(self):
		if self.rect.collidepoint(pygame.mouse.get_pos()):
			self.image = self.over
		else:
			self.image = self._image	

def load_image(name):
	fullname = os.path.join(data_file, name)
	print fullname
	try:
		image = pygame.image.load(fullname)
	except pygame.error, message:
		print 'Cannot load image:', name
		raise SystemExit, message
	image = image.convert()
	return image, image.get_rect()

def get_result():
	global max_seq
	result = b.start_game(n)
	if result == False:
		msg = "You Miss"
	elif result and n > max_seq:
		max_seq = n;
		msg = "Brilliant!"
	else:
		msg = "Well Done"
	text1 = font4.render(msg, 1, (80,10,10))
	textpos = text1.get_rect()
	textpos.center = (345, 225)
	screen.blit(bg, (0,0))
	screen.blit(text1,textpos)
	pygame.display.flip()
	pygame.time.wait(3000)
	

if __name__ == "__main__":
	f = open(os.path.join(data_file, 'high.dat'))
	max_seq = int(f.read().strip())
	f.close()

	pygame.init()
	fonts = pygame.font.get_fonts()
	if 'bachelorpadcollegejl' in fonts and 'bachelorpadjl' in fonts:
		tmp = pygame.font.match_font('bachelorpadjl')
		font1 = pygame.font.Font(tmp, 26)
		tmp = pygame.font.match_font('bachelorpadcollegejl')
		font2 = pygame.font.Font(tmp, 40)
		tmp = pygame.font.match_font('bachelorpadcollegejl')
		font3 = pygame.font.Font(tmp, 70)
		tmp = pygame.font.match_font('bachelorpadcollegejl')
		font4 = pygame.font.Font(tmp, 100)
	else:
		font1 = pygame.font.Font(None, 30)
		font2 = pygame.font.Font(None, 40)
		font3 = pygame.font.Font(None, 70)
		font4 = pygame.font.Font(None, 100)
	
	window = pygame.display.set_mode((685,600))
	pygame.display.set_caption(caption)
	screen = pygame.display.get_surface()

	bg,rect = load_image('bg.jpg')
	screen.blit(bg, (0,0))
	pygame.display.flip()
	
	g_button = pygame.sprite.Group()
	easy = button(1,275,'easy.jpg', 1.5)
	easy.add(g_button)
	normal = button(1,394,'normal.jpg', 1)
	normal.add(g_button)
	hard = button(1,560,'hard.jpg', 0.5)
	hard.add(g_button)
	button = [easy, normal, hard]

	b = Board()
	b.find_board()
	n = 0
	while True:
		events = pygame.event.get()
		for event in events: 
			if event.type == pygame.QUIT: 
				pygame.quit()
				f = open(os.path.join(data_file, 'high.dat'), 'w')
				f.write(str(max_seq))
				f.close()
				sys.exit(0)
			elif event.type == pygame.MOUSEBUTTONDOWN:
				for x in button:
					if x.rect.collidepoint(pygame.mouse.get_pos()):
						#click
						#n = x.val
						#get_result()
						b.speed = x.val

			elif event.type == pygame.KEYDOWN:
				if event.key == pygame.K_UP:
					n += 1
				elif event.key == pygame.K_DOWN:
					n -= 1
					if n < 0:
						n = 0
				elif event.key == pygame.K_RETURN:
					if n > 0:
						get_result()
			else:
				pass
				#print event 
		screen.blit(bg, (0,0))
		
		if n > 0:
			text1 = font3.render("sequence %d" %n, 1, (10,10,80))
			textpos = text1.get_rect()
			textpos.topleft = (50, 50)
			screen.blit(text1,textpos)
		else:
			text1 = font1.render("Choose speed below and press 'UP' 'DOWN' button", 1, (10,10,80))
			textpos = text1.get_rect()
			textpos.topleft = (15, 50)
			screen.blit(text1,textpos)
			text2 = font1.render("to specify your sequence and start with 'ENTER'", 1, (10,10,80))
			textpos = text2.get_rect()
			textpos.topleft = (15, 80)
			screen.blit(text2,textpos)
			
		text1 = font1.render("Hight Score", 1, (10,10,80))
		textpos = text1.get_rect()
		textpos.center = (485, 175)
		screen.blit(text1,textpos)
		text1 = font4.render("%d" %max_seq, 1, (10,10,80))
		textpos = text1.get_rect()
		textpos.center = (485, 230)
		screen.blit(text1,textpos)
		g_button.update()
		g_button.draw(screen)
		pygame.display.flip()
