#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include "usbdrv.h"

#define MAX_INDEX	12
#define set_led		0
#define get_but		1

uint8_t play=20;

void out_c(uint8_t pin, uint8_t val)
{
	DDRC |= 1<<pin;
	if(val)
		PORTC |= 1<<pin;
	else
		PORTC &= ~(1<<pin);
}

usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
	usbRequest_t *rq = (void*) data;
	static uchar dataBuffer[1];
	if (rq->bRequest == set_led)
	{
		uint8_t pin = rq->wValue.bytes[0];
		uint8_t val = rq->wIndex.bytes[0];
		out_c(pin, val);
		return 0;
	}
	else if(rq->bRequest == get_but)
	{
		dataBuffer[0] = PINB;
		usbMsgPtr = dataBuffer;
		return 1;
	}
	return 0;
}

int main()
{
	usbInit();
	usbDeviceDisconnect();
	_delay_ms(300);
	usbDeviceConnect();
	sei();
	DDRB = 0b00000000;
	DDRC = 0b00011111;
	PORTB = 0b11111111;
	PORTC = 0b00000000;
	while(1)
	{
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
		_delay_ms(20); usbPoll();
	}
	return 0;
}

